﻿/**
 * This sample illustrates how to define an IBMi OS command (with parameters).
 * The sample executes the CPY command to copy file from one directory to another.
 **/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Model;
using Util;

namespace ExecuteOSCommand
{
	public partial class MainForm : Form
	{
		private DataContext context;

		public MainForm(ConnectionForm cf)
		{
			InitializeComponent();

			//
			context = new DataContext(false);
			context.Connect(cf.Server, cf.PortNumber, cf.Partition, cf.UserName, cf.Password);
		}

		private void btnCopy_Click(object sender, EventArgs e)
		{
			string sourcePath = txtSource.Text;
			string targetDir = txtTarget.Text;

			//
			try
			{
				// Use the 'Copy' command defined in the data model
				context.OSCommands.Copy.Execute(sourcePath, targetDir);

				//
				MessageBox.Show("File has been copied successfully.");
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Error");
			}
		}
	}
}
