using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using LOpen.EntityModel;
using HR;

namespace HRWebApplication
{
	/// <summary>
	/// This web page allows the user the enter in the server they want to connect to
	/// (and other relevant connection details).
	/// </summary>
    public partial class Default : System.Web.UI.Page
    {
        protected void btnOK_Click(object sender, EventArgs e)
        {
            try
            {
                string server = boxServerName.Text;
                int port = int.Parse(boxPortNumber.Text);
                string partition = boxPartition.Text;
                string username = boxUsername.Text;
                string password = boxPassword.Text;

                // Test settings
                using (DataContext c = new DataContext(false))
                {
                    c.Settings.Server = server;
                    c.Settings.PortNumber = port;
                    c.Settings.Partition = partition;
                    c.Connect(username, password);
                }
                lblMessage.Visible = false;

                //
                string url = "MainPage.aspx?server={0}&port={1}&partition={2}&lang={3}&user={4}&pwd={5}";
                url = string.Format(url, HttpUtility.UrlEncode(server), port, HttpUtility.UrlEncode(partition), HttpUtility.UrlEncode("ENG"), HttpUtility.UrlEncode(username), HttpUtility.UrlEncode(password));
                Response.Redirect(url);
            }
            catch (Exception ex)
            {
                lblMessage.Text = ex.Message;
                lblMessage.Visible = true;
            }
        }
    }
}
