using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;

using LOpen.EntityModel;

namespace HRWebApplication
{
    public class Global : System.Web.HttpApplication
    {
        protected void Application_Start(object sender, EventArgs e)
        {
			// Enable connection pooling
            ConnectionPool.Enabled = true;

			// Wait for a maximum of 30 seconds when attempting to acquire a connection
			// An error will be raised when no connection can be acquired after 30 seconds
			// (e.g. when the pool has reached its maximum size)
			ConnectionPool.AcquireConnectionTimeout = 30; // 30 seconds

			// Maximum of 10 connections in the pool
			ConnectionPool.MaxPoolSize = 10;

			// Minimum of 2 connections in the pool
			ConnectionPool.MinPoolSize = 2;

			// Inactive connection will be shutdown and removed from the pool after 600 seconds
			ConnectionPool.InactiveConnectionTimeout = 600; // 600 seconds = 10 minutes
		}
    }
}