﻿Public Class ConflictForm
    Private ReadOnly conflict As ObjectChangeConflict

    Public Sub New(ByVal ex As ApplyChangesException)
        InitializeComponent()

        ' 
        conflict = ex.ChangeConflicts(0)

        '
        Dim top As Integer = 0

        '
        For Each mcc As MemberChangeConflict In conflict.MemberConflicts
            Dim labelField As New Label()
            labelField.Text = mcc.Column.Label
            labelField.Top = top
            panelFields.Controls.Add(labelField)

            Dim labelMyValue As New Label()
            labelMyValue.Top = top
            labelMyValue.Text = mcc.CurrentValue.ToString()
            panelMyValues.Controls.Add(labelMyValue)

            Dim labelDbValue As New Label()
            labelDbValue.Top = top
            labelDbValue.Text = mcc.DatabaseValue.ToString()
            panelDbValues.Controls.Add(labelDbValue)

            Dim buttonPanel As New Panel()
            buttonPanel.Left = 0
            buttonPanel.Width = panelActions.Width
            buttonPanel.Top = top

            Dim btnKeepMyValue As New Button()
            btnKeepMyValue.AutoSize = True
            btnKeepMyValue.Text = "Keep Mine"
            btnKeepMyValue.Tag = mcc
            AddHandler btnKeepMyValue.Click, AddressOf btnKeepMyValue_Click
            buttonPanel.Controls.Add(btnKeepMyValue)

            Dim btnKeepDbValue As New Button()
            btnKeepDbValue.Text = "Keep Database"
            btnKeepDbValue.AutoSize = True
            btnKeepDbValue.Left = btnKeepMyValue.Right + 5
            btnKeepDbValue.Tag = mcc
            AddHandler btnKeepDbValue.Click, AddressOf btnKeepDbValue_Click
            buttonPanel.Controls.Add(btnKeepDbValue)

            buttonPanel.Height = btnKeepDbValue.Height
            panelActions.Controls.Add(buttonPanel)

            '
            top += 25
        Next
    End Sub

    Private Sub btnKeepDbValue_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        Dim memberInfo As MemberChangeConflict = DirectCast(btn.Tag, MemberChangeConflict)
        memberInfo.Resolve(ConflictResolveMode.OverwriteCurrentValues)
        btn.Font = New Font(btn.Font, FontStyle.Bold)
        For Each c As Control In btn.Parent.Controls
            c.Enabled = False
        Next
    End Sub

    Private Sub btnKeepMyValue_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        Dim memberInfo As MemberChangeConflict = DirectCast(btn.Tag, MemberChangeConflict)
        memberInfo.Resolve(ConflictResolveMode.KeepCurrentValues)
        btn.Font = New Font(btn.Font, FontStyle.Bold)
        For Each c As Control In btn.Parent.Controls
            c.Enabled = False
        Next
    End Sub

    Private Sub btnKeepAllMyValues_Click(ByVal sender As Object, ByVal e As EventArgs)
        conflict.Resolve(ConflictResolveMode.KeepCurrentValues)
    End Sub

    Private Sub btnKeepAllDbValues_Click(ByVal sender As Object, ByVal e As EventArgs)
        conflict.Resolve(ConflictResolveMode.OverwriteCurrentValues)
    End Sub
End Class