'*
' * This sample illustrates how to define an IBMi OS command (with parameters).
' * The sample executes the CPY command to copy file from one directory to another.
' *


Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Public Class MainForm
    Private context As DataContext

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        context = New DataContext(False)
        Using cf As New Util.ConnectionForm
            cf.ShowDialog()
            context.Connect(cf.Server, cf.PortNumber, cf.Partition, cf.UserName, cf.Password)
        End Using
    End Sub

    Private Sub btnCopy_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnCopy.Click
        Dim sourcePath As String = txtSource.Text
        Dim targetDir As String = txtTarget.Text

        '
        Try
            ' Use the 'Copy' command defined in the data model
            context.OSCommands.Copy.Execute(sourcePath, targetDir)

            '
            MessageBox.Show("File has been copied successfully.")
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error")
        End Try
    End Sub
End Class
