'*
' * This sample illustrates how to send an email message on an IBMi system.
' *

Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Imports LOpen.EntityModel

Public Partial Class MainForm
	Inherits Form
    Private context As DataContext

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        context = New DataContext(False)

        Using cf As New ConnectionForm
            cf.ShowDialog()
            context.Connect(cf.Server, cf.PortNumber, cf.Partition, cf.UserName, cf.Password)
        End Using
    End Sub

	' Send the message
    Private Sub btnSend_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSend.Click
        ' Create and setup an email message object
        Dim message = New IbmMailMessage()

        message.Sender = txtFrom.Text
        message.Subject = txtSubject.Text
        message.Body = txtBody.Text

        ' Parse target and cc addresses & add the the respective lists
        ParseAndAddAddresses(txtTo.Text, message.ToList)
        ParseAndAddAddresses(txtCc.Text, message.CCList)

        '
        Try
            ' Send the email
            context.Ibm.SendMail(message)
            MessageBox.Show("Message has been sent successfully.", "OK")
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error")
        End Try
    End Sub

	' Parse email addresses (separated by comma or semi-colon
	' and add to the specified address list in an email message.
	Private Sub ParseAndAddAddresses(addresses As String, addressList As IbmMailAddressList)
		Dim separator As System.Nullable(Of Char) = Nothing
		addresses = addresses.Trim()

		'
		If addresses.Length > 0 Then
			If addresses.Contains(",") Then
				separator = ","C
			ElseIf addresses.Contains(";") Then
				separator = ";"C
			End If

			'
			Dim addrArray As String() = {addresses}
			If separator IsNot Nothing Then
				addrArray = addresses.Split(separator.Value)
			End If

			'
			For Each addr As String In addrArray
				addressList.Add(addr)
			Next
		End If
	End Sub

End Class
