'*
' * This sample illustrates how to upload and download file from the server.
' * 
' * Key methods:
' *   DataContext.Services.TransferFileToServer
' *   DataContext.Services.TransferFileToClient
' *

Public Partial Class MainForm
	Inherits Form
    Private context As DataContext

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        context = New DataContext(False)

        Using cf As New ConnectionForm
            cf.ShowDialog()
            context.Connect(cf.Server, cf.PortNumber, cf.Partition, cf.UserName, cf.Password)
        End Using
    End Sub

	Private Sub btnChooseFileToUpload_Click(sender As Object, e As EventArgs)
		If Me.openFileDialog.ShowDialog() = DialogResult.OK Then
			Me.txtFileToUpload.Text = Me.openFileDialog.FileName
		End If
	End Sub

	Private Sub btnChooseTargetFolder_Click(sender As Object, e As EventArgs)
		If Me.folderBrowserDialog.ShowDialog() = DialogResult.OK Then
			Me.txtTargetFolder.Text = Me.folderBrowserDialog.SelectedPath
		End If
	End Sub

	Private Sub btnUpload_Click(sender As Object, e As EventArgs)
		Dim sourcePath As String = Me.txtFileToUpload.Text
		Dim targetPath As String = Me.txtUploadTo.Text.Trim()

		'
		Dim fileName As String = Path.GetFileName(sourcePath)
		If Not targetPath.EndsWith("/") AndAlso Not targetPath.EndsWith("\") Then
			targetPath += "/"
		End If
		targetPath += fileName

		'
		If sourcePath.Length > 0 Then
			Try
				context.Services.TransferFileToServer(sourcePath, targetPath, FileTransferMode.Binary)
				MessageBox.Show("The file has been uploaded successfully.", "OK")
			Catch ex As Exception
				MessageBox.Show(ex.Message, "Error")
			End Try
		Else
			MessageBox.Show("Please choose file to upload", "Error")
		End If
	End Sub

	Private Sub btnDownload_Click(sender As Object, e As EventArgs)
		Dim folder As String = Me.txtTargetFolder.Text
		If folder.Length > 0 Then
			Dim sourcePath As String = Me.txtFileToDownload.Text
			Dim targetPath As String = Me.txtTargetFolder.Text

			'
			Dim fileName As String = Path.GetFileName(sourcePath)
			targetPath = Path.Combine(targetPath, fileName)

			'
			If sourcePath.Length > 0 AndAlso targetPath.Length > 0 Then
				Try
					context.Services.TransferFileToClient(sourcePath, targetPath, FileTransferMode.Binary)
					MessageBox.Show("The file has been downloaded successfully.", "OK")
				Catch ex As Exception
					MessageBox.Show(ex.Message, "Error")
				End Try
			Else
				MessageBox.Show("Please choose file to download & target folder", "Error")
			End If
		Else
			MessageBox.Show("Please choose target folder to download the file to", "Error")
		End If
	End Sub
End Class
