using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using System.Linq;
using System.Xml.Linq;

using ModelTest;
using LOpen.EntityModel;

namespace Tutorials
{
	public partial class Tutorial7
	{
		private DataContext MasterContext = new DataContext(false);

		private void Connect()
		{
			// Specify most details in the Settings object
			MasterContext.Settings.Server = "MyServer";
			MasterContext.Settings.Partition = "DEM";
			MasterContext.Settings.PortNumber = 4545;

			// Connect
			try
			{
				MasterContext.Connect("MyUsername", "MyPassword");
			}
			catch (System.Exception exc)
			{
				MessageBox.Show("Error when trying to connect: " + exc.Message, "Connection", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign, false);
			}
		}

		private void btnConnect_Click(System.Object sender, System.EventArgs e)
		{
			Connect();
		}

		private void btnExecAdd_Click(System.Object sender, System.EventArgs e)
		{
			// Create an 'invoke info' object where you put all the parameters
			// you need to pass when calling the server function.
			// After the function is executed, any values returned by the server
			// are available in the 'invoke info' object as well.
			var invokeInfo = MasterContext.Add.CreateInvokeInfo();
			invokeInfo.In.Number1 = (long)TextBox1.Value;
			invokeInfo.In.Number2 = (long)TextBox2.Value;

			// Invoke the function, passing the parameters
			MasterContext.Add.Invoke(invokeInfo);

			// Get the result returned by the function
			TextBox3.Text = invokeInfo.Out.Result.ToString();

		}

		private void btnExecSum_Click(System.Object sender, System.EventArgs e)
		{
			// Create an 'invoke info' object where you put all the parameters
			// you need to pass when calling the server function.
			// After the function is executed, any values returned by the server
			// are available in the 'invoke info' object as well.
			var invokeInfo = MasterContext.SUM.CreateInvokeInfo();

			//Add values to sum to the list
			var item1 = new SUM_ValuesItem();
			item1.Number = (long)TextBox1.Value;
			invokeInfo.Lists.Values.Add(item1);

			SUM_ValuesItem item2 = new SUM_ValuesItem();
			item2.Number = (long)TextBox2.Value;
			invokeInfo.Lists.Values.Add(item2);

			// Invoke the function, passing the parameters
			MasterContext.SUM.Invoke(invokeInfo);

			// Get the result returned by the function
			TextBox3.Text = invokeInfo.Out.Result.ToString();

		}

		public Tutorial7()
		{
			InitializeComponent();
		}
	}
}