using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using System.Linq;
using System.Xml.Linq;

using ModelTest;
using LOpen.EntityModel;

namespace Tutorials
{

	public partial class Tutorial8
	{

		DataContext MasterContext = new DataContext(false);
		private void Connect()
		{
			// Specify most details in the Settings object
			MasterContext.Settings.Server = "MyServer";
			MasterContext.Settings.Partition = "DEM";
			MasterContext.Settings.PortNumber = 4545;

			// Connect
			try
			{
				MasterContext.Connect("MyUsername", "MyPassword");
			}
			catch (System.Exception exc)
			{
				MessageBox.Show("Error when trying to connect: " + exc.Message, "Connection", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign, false);
			}
		}

		private void btnConnect_Click(System.Object sender, System.EventArgs e)
		{
			Connect();
		}

		private void btnExecuteFunction_Click(System.Object sender, System.EventArgs e)
		{
			lvwSkills.Items.Clear();

			// Create an 'invoke info' object where you put all the parameters
			// you need to pass when calling the server function.
			// After the function is executed, any values returned by the server
			// are available in the 'invoke info' object as well.
			var Info = MasterContext.GetDetailsAndSkills.CreateInvokeInfo();

			// Pass the employee number
			Info.In.EMPNO = TextBox1.Text;

			// Invoke the function
			MasterContext.GetDetailsAndSkills.Invoke(Info);

			// Get the employee details
			TextBox2.Text = Info.Out.SURNAME;
			TextBox3.Text = Info.Out.GIVENAME;
			TextBox4.Text = Info.Out.ADDRESS1;
			TextBox5.Text = Info.Out.ADDRESS2;
			TextBox6.Value = Info.Out.SALARY;

			// Get the skills for the employee
			String[] listData = new String[4];
			ListViewItem listRow = null;
			int count = Info.Lists.Skills.Count;
			for (int i = 0; i <= count - 1; i++)
			{
				listData[0] = Info.Lists.Skills[i].SKILCODE;
				listData[1] = Info.Lists.Skills[i].SKILDESC;
				listData[2] = Info.Lists.Skills[i].GRADEDES;
				listData[3] = Info.Lists.Skills[i].COMMENT;
				listRow = new ListViewItem(listData);
				lvwSkills.Items.Add(listRow);
			}

		}
		public Tutorial8()
		{
			InitializeComponent();
		}

	}
}

