﻿Imports Tutorials.Model

Public Class Tutorial3
    Dim MasterContext As New DataContext(False)

    Private Sub Connect()
        ' Specify most details in the Settings object
        MasterContext.Settings.Server = "MyServer"
        MasterContext.Settings.Partition = "DEM"
        MasterContext.Settings.PortNumber = 4545

        ' Connect
        Try
            MasterContext.Connect("MyUsername", "MyPassword")
            MessageBox.Show("Connected to the Server.", "Connection", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly, False)
        Catch exc As System.Exception
            MessageBox.Show("Error when trying to connect.", "Connection", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign, False)
        End Try

        '
        btnConnect.Enabled = False
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DataGridView1.AutoGenerateColumns = False
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Connect()
    End Sub

    Private Sub btnRetrieveAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim personList As Person() = MasterContext.Persons.RetrieveList()

        'assign the results to DataGridView1
        DataGridView1.DataSource = personList
    End Sub

    Private Sub btnRetrieveSomeColumns_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim columns = PersonCols.GIVENAME + PersonCols.SURNAME
        Dim personList = MasterContext.Persons.RetrieveList(columns)

        'assign the results to DataGridView1
        DataGridView1.DataSource = personList
    End Sub

    Private Sub btnRetrieveCondition1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim condition = PersonExprs.SALARY > 50000
        Dim personList = MasterContext.Persons.RetrieveList(condition)

        'assign the results to DataGridView1
        DataGridView1.DataSource = personList
    End Sub

    Private Sub btnCondition2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim condition = (PersonExprs.SALARY > 50000).And(PersonExprs.SALARY < 100000)
        Dim personList = MasterContext.Persons.RetrieveList(condition)

        'assign the results to DataGridView1
        DataGridView1.DataSource = personList
    End Sub

    Private Sub btnRetrieveExactMatch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim personList = MasterContext.Persons.RetrieveList(True, "A0070")

        'assign the results to DataGridView1
        DataGridView1.DataSource = personList
    End Sub

    Private Sub btnRetrievePartialMatch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim personList = MasterContext.Persons.RetrieveList(False, "A1")

        'assign the results to DataGridView1
        DataGridView1.DataSource = personList
    End Sub

    Private Sub btnRetrieveLogicalTable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim personList = MasterContext.Persons_by_SNameGName.RetrieveList(False, "S")

        'assign the results to DataGridView1
        DataGridView1.DataSource = personList
    End Sub
End Class