﻿Imports Tutorials.ModelTest

Public Class Tutorial7
    Dim MasterContext As New DataContext(False)

    Private Sub Connect()
        ' Specify most details in the Settings object
        MasterContext.Settings.Server = "MyServer"
        MasterContext.Settings.Partition = "DEM"
        MasterContext.Settings.PortNumber = 4545

        ' Connect
        Try
            MasterContext.Connect("MyUsername", "MyPassword")
      Catch exc As System.Exception
         MessageBox.Show("Error when trying to connect.", "Connection", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign, False)
        End Try
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Call Connect()
    End Sub

    Private Sub btnExecAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ' Create an 'invoke info' object where you put all the parameters
        ' you need to pass when calling the server function.
        ' After the function is executed, any values returned by the server
        ' are available in the 'invoke info' object as well.
        Dim invokeInfo = MasterContext.Add.CreateInvokeInfo()
        invokeInfo.In.Number1 = TextBox1.Value
        invokeInfo.In.Number2 = TextBox2.Value

        ' Invoke the function, passing the parameters
        MasterContext.Add.Invoke(invokeInfo)

        ' Get the result returned by the function

        TextBox3.Text = invokeInfo.Out.Result

    End Sub

    Private Sub btnExecSum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ' Create an 'invoke info' object where you put all the parameters
        ' you need to pass when calling the server function.
        ' After the function is executed, any values returned by the server
        ' are available in the 'invoke info' object as well.
        Dim invokeInfo = MasterContext.SUM.CreateInvokeInfo()

        'Add values to sum to the list
        Dim item1 As New SUM_ValuesItem()
        item1.Number = TextBox1.Value
        invokeInfo.Lists.Values.Add(item1)

        Dim item2 As New SUM_ValuesItem()
        item2.Number = TextBox2.Value
        invokeInfo.Lists.Values.Add(item2)

        ' Invoke the function, passing the parameters
        MasterContext.SUM.Invoke(invokeInfo)

        ' Get the result returned by the function
        TextBox3.Text = invokeInfo.Out.Result
    End Sub
End Class

