﻿Imports Tutorials.ModelTest

Public Class Tutorial8
    Dim MasterContext As New DataContext(False)

    Private Sub Connect()
        ' Specify most details in the Settings object
        MasterContext.Settings.Server = "MyServer"
        MasterContext.Settings.Partition = "DEM"
        MasterContext.Settings.PortNumber = 4545

        ' Connect
        Try
            MasterContext.Connect("MyUsername", "MyPassword")
      Catch exc As System.Exception
         MessageBox.Show("Error when trying to connect: " & exc.Message, "Connection", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign, False)
        End Try
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Call Connect()
    End Sub

    Private Sub btnExecuteFunction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        lvwSkills.Items.Clear()

        ' Create an 'invoke info' object where you put all the parameters
        ' you need to pass when calling the server function.
        ' After the function is executed, any values returned by the server
        ' are available in the 'invoke info' object as well.
        Dim Info = MasterContext.GetDetailsAndSkills.CreateInvokeInfo()

        ' Pass the employee number
        Info.In.EMPNO = TextBox1.Text

        ' Invoke the function
        MasterContext.GetDetailsAndSkills.Invoke(Info)

        ' Get the employee details
        TextBox2.Text = Info.Out.SURNAME
        TextBox3.Text = Info.Out.GIVENAME
        TextBox4.Text = Info.Out.ADDRESS1
        TextBox5.Text = Info.Out.ADDRESS2
        TextBox6.Value = Info.Out.SALARY

        ' Get the skills for the employee
        Dim listData As [String]() = New [String](3) {}
        Dim listRow As ListViewItem
        Dim count As Integer = Info.Lists.Skills.Count
        For i As Integer = 0 To count - 1
            listData(0) = Info.Lists.Skills(i).SKILCODE
            listData(1) = Info.Lists.Skills(i).SKILDESC
            listData(2) = Info.Lists.Skills(i).GRADEDES
            listData(3) = Info.Lists.Skills(i).COMMENT
            listRow = New ListViewItem(listData)
            lvwSkills.Items.Add(listRow)
        Next
    End Sub

End Class

